import time
import pytest
import numpy as np
import LKHpy as LK

test_data = [
    ([[0,8,50,31,12,48,36,2,5,39,10],[8,0,38,9,33,37,22,6,4,14,32],[50,38,0,11,55,1,23,46,41,17,52],[31,9,11,0,44,13,16,19,25,18,42],[12,33,55,44,0,54,53,30,28,45,7],[48,37,1,13,54,0,26,47,40,24,51],[36,22,23,16,53,26,0,29,35,34,49],[2,6,46,19,30,47,29,0,3,27,15],[5,4,41,25,28,40,35,3,0,20,21],[39,14,17,18,45,24,34,27,20,0,43],[10,32,52,42,7,51,49,15,21,43,0]], 10, 0.01)
]

@pytest.mark.parametrize("cost_matrix, runs, target_timing_per_run", test_data)
def test_performance(cost_matrix, runs, target_timing_per_run):
    params = {
        'RUNS' : runs
    }
    start = time.time()
    LK.cost_matrix(cost_matrix, params)
    averageRunTime = (time.time() - start) / runs
    assert averageRunTime < target_timing_per_run, f"Expected less than {target_timing_per_run} seconds, got {averageRunTime}"